"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2022 Google LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.field_mask_pb2
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.type.expr_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _ServiceAccountKeyAlgorithm:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ServiceAccountKeyAlgorithmEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ServiceAccountKeyAlgorithm.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    KEY_ALG_UNSPECIFIED: _ServiceAccountKeyAlgorithm.ValueType  # 0
    """An unspecified key algorithm."""
    KEY_ALG_RSA_1024: _ServiceAccountKeyAlgorithm.ValueType  # 1
    """1k RSA Key."""
    KEY_ALG_RSA_2048: _ServiceAccountKeyAlgorithm.ValueType  # 2
    """2k RSA Key."""

class ServiceAccountKeyAlgorithm(_ServiceAccountKeyAlgorithm, metaclass=_ServiceAccountKeyAlgorithmEnumTypeWrapper):
    """Supported key algorithms."""

KEY_ALG_UNSPECIFIED: ServiceAccountKeyAlgorithm.ValueType  # 0
"""An unspecified key algorithm."""
KEY_ALG_RSA_1024: ServiceAccountKeyAlgorithm.ValueType  # 1
"""1k RSA Key."""
KEY_ALG_RSA_2048: ServiceAccountKeyAlgorithm.ValueType  # 2
"""2k RSA Key."""
global___ServiceAccountKeyAlgorithm = ServiceAccountKeyAlgorithm

class _ServiceAccountPrivateKeyType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ServiceAccountPrivateKeyTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ServiceAccountPrivateKeyType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    TYPE_UNSPECIFIED: _ServiceAccountPrivateKeyType.ValueType  # 0
    """Unspecified. Equivalent to `TYPE_GOOGLE_CREDENTIALS_FILE`."""
    TYPE_PKCS12_FILE: _ServiceAccountPrivateKeyType.ValueType  # 1
    """PKCS12 format.
    The password for the PKCS12 file is `notasecret`.
    For more information, see https://tools.ietf.org/html/rfc7292.
    """
    TYPE_GOOGLE_CREDENTIALS_FILE: _ServiceAccountPrivateKeyType.ValueType  # 2
    """Google Credentials File format."""

class ServiceAccountPrivateKeyType(_ServiceAccountPrivateKeyType, metaclass=_ServiceAccountPrivateKeyTypeEnumTypeWrapper):
    """Supported private key output formats."""

TYPE_UNSPECIFIED: ServiceAccountPrivateKeyType.ValueType  # 0
"""Unspecified. Equivalent to `TYPE_GOOGLE_CREDENTIALS_FILE`."""
TYPE_PKCS12_FILE: ServiceAccountPrivateKeyType.ValueType  # 1
"""PKCS12 format.
The password for the PKCS12 file is `notasecret`.
For more information, see https://tools.ietf.org/html/rfc7292.
"""
TYPE_GOOGLE_CREDENTIALS_FILE: ServiceAccountPrivateKeyType.ValueType  # 2
"""Google Credentials File format."""
global___ServiceAccountPrivateKeyType = ServiceAccountPrivateKeyType

class _ServiceAccountPublicKeyType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ServiceAccountPublicKeyTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ServiceAccountPublicKeyType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    TYPE_NONE: _ServiceAccountPublicKeyType.ValueType  # 0
    """Do not return the public key."""
    TYPE_X509_PEM_FILE: _ServiceAccountPublicKeyType.ValueType  # 1
    """X509 PEM format."""
    TYPE_RAW_PUBLIC_KEY: _ServiceAccountPublicKeyType.ValueType  # 2
    """Raw public key."""

class ServiceAccountPublicKeyType(_ServiceAccountPublicKeyType, metaclass=_ServiceAccountPublicKeyTypeEnumTypeWrapper):
    """Supported public key output formats."""

TYPE_NONE: ServiceAccountPublicKeyType.ValueType  # 0
"""Do not return the public key."""
TYPE_X509_PEM_FILE: ServiceAccountPublicKeyType.ValueType  # 1
"""X509 PEM format."""
TYPE_RAW_PUBLIC_KEY: ServiceAccountPublicKeyType.ValueType  # 2
"""Raw public key."""
global___ServiceAccountPublicKeyType = ServiceAccountPublicKeyType

class _ServiceAccountKeyOrigin:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ServiceAccountKeyOriginEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ServiceAccountKeyOrigin.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    ORIGIN_UNSPECIFIED: _ServiceAccountKeyOrigin.ValueType  # 0
    """Unspecified key origin."""
    USER_PROVIDED: _ServiceAccountKeyOrigin.ValueType  # 1
    """Key is provided by user."""
    GOOGLE_PROVIDED: _ServiceAccountKeyOrigin.ValueType  # 2
    """Key is provided by Google."""

class ServiceAccountKeyOrigin(_ServiceAccountKeyOrigin, metaclass=_ServiceAccountKeyOriginEnumTypeWrapper):
    """Service Account Key Origin."""

ORIGIN_UNSPECIFIED: ServiceAccountKeyOrigin.ValueType  # 0
"""Unspecified key origin."""
USER_PROVIDED: ServiceAccountKeyOrigin.ValueType  # 1
"""Key is provided by user."""
GOOGLE_PROVIDED: ServiceAccountKeyOrigin.ValueType  # 2
"""Key is provided by Google."""
global___ServiceAccountKeyOrigin = ServiceAccountKeyOrigin

class _RoleView:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _RoleViewEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_RoleView.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    BASIC: _RoleView.ValueType  # 0
    """Omits the `included_permissions` field.
    This is the default value.
    """
    FULL: _RoleView.ValueType  # 1
    """Returns all fields."""

class RoleView(_RoleView, metaclass=_RoleViewEnumTypeWrapper):
    """A view for Role objects."""

BASIC: RoleView.ValueType  # 0
"""Omits the `included_permissions` field.
This is the default value.
"""
FULL: RoleView.ValueType  # 1
"""Returns all fields."""
global___RoleView = RoleView

@typing.final
class ServiceAccount(google.protobuf.message.Message):
    """An IAM service account.

    A service account is an account for an application or a virtual machine (VM)
    instance, not a person. You can use a service account to call Google APIs. To
    learn more, read the [overview of service
    accounts](https://cloud.google.com/iam/help/service-accounts/overview).

    When you create a service account, you specify the project ID that owns the
    service account, as well as a name that must be unique within the project.
    IAM uses these values to create an email address that identifies the service
    account.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PROJECT_ID_FIELD_NUMBER: builtins.int
    UNIQUE_ID_FIELD_NUMBER: builtins.int
    EMAIL_FIELD_NUMBER: builtins.int
    DISPLAY_NAME_FIELD_NUMBER: builtins.int
    ETAG_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    OAUTH2_CLIENT_ID_FIELD_NUMBER: builtins.int
    DISABLED_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The resource name of the service account.

    Use one of the following formats:

    * `projects/{PROJECT_ID}/serviceAccounts/{EMAIL_ADDRESS}`
    * `projects/{PROJECT_ID}/serviceAccounts/{UNIQUE_ID}`

    As an alternative, you can use the `-` wildcard character instead of the
    project ID:

    * `projects/-/serviceAccounts/{EMAIL_ADDRESS}`
    * `projects/-/serviceAccounts/{UNIQUE_ID}`

    When possible, avoid using the `-` wildcard character, because it can cause
    response messages to contain misleading error codes. For example, if you
    try to get the service account
    `projects/-/serviceAccounts/fake@example.com`, which does not exist, the
    response contains an HTTP `403 Forbidden` error instead of a `404 Not
    Found` error.
    """
    project_id: builtins.str
    """Output only. The ID of the project that owns the service account."""
    unique_id: builtins.str
    """Output only. The unique, stable numeric ID for the service account.

    Each service account retains its unique ID even if you delete the service
    account. For example, if you delete a service account, then create a new
    service account with the same name, the new service account has a different
    unique ID than the deleted service account.
    """
    email: builtins.str
    """Output only. The email address of the service account."""
    display_name: builtins.str
    """Optional. A user-specified, human-readable name for the service account. The maximum
    length is 100 UTF-8 bytes.
    """
    etag: builtins.bytes
    """Deprecated. Do not use."""
    description: builtins.str
    """Optional. A user-specified, human-readable description of the service account. The
    maximum length is 256 UTF-8 bytes.
    """
    oauth2_client_id: builtins.str
    """Output only. The OAuth 2.0 client ID for the service account."""
    disabled: builtins.bool
    """Output only. Whether the service account is disabled."""
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        project_id: builtins.str = ...,
        unique_id: builtins.str = ...,
        email: builtins.str = ...,
        display_name: builtins.str = ...,
        etag: builtins.bytes = ...,
        description: builtins.str = ...,
        oauth2_client_id: builtins.str = ...,
        disabled: builtins.bool = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["description", b"description", "disabled", b"disabled", "display_name", b"display_name", "email", b"email", "etag", b"etag", "name", b"name", "oauth2_client_id", b"oauth2_client_id", "project_id", b"project_id", "unique_id", b"unique_id"]) -> None: ...

global___ServiceAccount = ServiceAccount

@typing.final
class CreateServiceAccountRequest(google.protobuf.message.Message):
    """The service account create request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    ACCOUNT_ID_FIELD_NUMBER: builtins.int
    SERVICE_ACCOUNT_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the project associated with the service
    accounts, such as `projects/my-project-123`.
    """
    account_id: builtins.str
    """Required. The account id that is used to generate the service account
    email address and a stable unique id. It is unique within a project,
    must be 6-30 characters long, and match the regular expression
    `[a-z]([-a-z0-9]*[a-z0-9])` to comply with RFC1035.
    """
    @property
    def service_account(self) -> global___ServiceAccount:
        """The [ServiceAccount][google.iam.admin.v1.ServiceAccount] resource to
        create. Currently, only the following values are user assignable:
        `display_name` and `description`.
        """

    def __init__(
        self,
        *,
        name: builtins.str = ...,
        account_id: builtins.str = ...,
        service_account: global___ServiceAccount | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["service_account", b"service_account"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["account_id", b"account_id", "name", b"name", "service_account", b"service_account"]) -> None: ...

global___CreateServiceAccountRequest = CreateServiceAccountRequest

@typing.final
class ListServiceAccountsRequest(google.protobuf.message.Message):
    """The service account list request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the project associated with the service
    accounts, such as `projects/my-project-123`.
    """
    page_size: builtins.int
    """Optional limit on the number of service accounts to include in the
    response. Further accounts can subsequently be obtained by including the
    [ListServiceAccountsResponse.next_page_token][google.iam.admin.v1.ListServiceAccountsResponse.next_page_token]
    in a subsequent request.

    The default is 20, and the maximum is 100.
    """
    page_token: builtins.str
    """Optional pagination token returned in an earlier
    [ListServiceAccountsResponse.next_page_token][google.iam.admin.v1.ListServiceAccountsResponse.next_page_token].
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "page_size", b"page_size", "page_token", b"page_token"]) -> None: ...

global___ListServiceAccountsRequest = ListServiceAccountsRequest

@typing.final
class ListServiceAccountsResponse(google.protobuf.message.Message):
    """The service account list response."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACCOUNTS_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    """To retrieve the next page of results, set
    [ListServiceAccountsRequest.page_token][google.iam.admin.v1.ListServiceAccountsRequest.page_token]
    to this value.
    """
    @property
    def accounts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ServiceAccount]:
        """The list of matching service accounts."""

    def __init__(
        self,
        *,
        accounts: collections.abc.Iterable[global___ServiceAccount] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["accounts", b"accounts", "next_page_token", b"next_page_token"]) -> None: ...

global___ListServiceAccountsResponse = ListServiceAccountsResponse

@typing.final
class GetServiceAccountRequest(google.protobuf.message.Message):
    """The service account get request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___GetServiceAccountRequest = GetServiceAccountRequest

@typing.final
class DeleteServiceAccountRequest(google.protobuf.message.Message):
    """The service account delete request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___DeleteServiceAccountRequest = DeleteServiceAccountRequest

@typing.final
class PatchServiceAccountRequest(google.protobuf.message.Message):
    """The service account patch request.

    You can patch only the `display_name` and `description` fields. You must use
    the `update_mask` field to specify which of these fields you want to patch.

    Only the fields specified in the request are guaranteed to be returned in
    the response. Other fields may be empty in the response.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SERVICE_ACCOUNT_FIELD_NUMBER: builtins.int
    UPDATE_MASK_FIELD_NUMBER: builtins.int
    @property
    def service_account(self) -> global___ServiceAccount: ...
    @property
    def update_mask(self) -> google.protobuf.field_mask_pb2.FieldMask: ...
    def __init__(
        self,
        *,
        service_account: global___ServiceAccount | None = ...,
        update_mask: google.protobuf.field_mask_pb2.FieldMask | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["service_account", b"service_account", "update_mask", b"update_mask"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["service_account", b"service_account", "update_mask", b"update_mask"]) -> None: ...

global___PatchServiceAccountRequest = PatchServiceAccountRequest

@typing.final
class UndeleteServiceAccountRequest(google.protobuf.message.Message):
    """The service account undelete request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT_UNIQUE_ID}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___UndeleteServiceAccountRequest = UndeleteServiceAccountRequest

@typing.final
class UndeleteServiceAccountResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RESTORED_ACCOUNT_FIELD_NUMBER: builtins.int
    @property
    def restored_account(self) -> global___ServiceAccount:
        """Metadata for the restored service account."""

    def __init__(
        self,
        *,
        restored_account: global___ServiceAccount | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["restored_account", b"restored_account"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["restored_account", b"restored_account"]) -> None: ...

global___UndeleteServiceAccountResponse = UndeleteServiceAccountResponse

@typing.final
class EnableServiceAccountRequest(google.protobuf.message.Message):
    """The service account enable request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___EnableServiceAccountRequest = EnableServiceAccountRequest

@typing.final
class DisableServiceAccountRequest(google.protobuf.message.Message):
    """The service account disable request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___DisableServiceAccountRequest = DisableServiceAccountRequest

@typing.final
class ListServiceAccountKeysRequest(google.protobuf.message.Message):
    """The service account keys list request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _KeyType:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _KeyTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ListServiceAccountKeysRequest._KeyType.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        KEY_TYPE_UNSPECIFIED: ListServiceAccountKeysRequest._KeyType.ValueType  # 0
        """Unspecified key type. The presence of this in the
        message will immediately result in an error.
        """
        USER_MANAGED: ListServiceAccountKeysRequest._KeyType.ValueType  # 1
        """User-managed keys (managed and rotated by the user)."""
        SYSTEM_MANAGED: ListServiceAccountKeysRequest._KeyType.ValueType  # 2
        """System-managed keys (managed and rotated by Google)."""

    class KeyType(_KeyType, metaclass=_KeyTypeEnumTypeWrapper):
        """`KeyType` filters to selectively retrieve certain varieties
        of keys.
        """

    KEY_TYPE_UNSPECIFIED: ListServiceAccountKeysRequest.KeyType.ValueType  # 0
    """Unspecified key type. The presence of this in the
    message will immediately result in an error.
    """
    USER_MANAGED: ListServiceAccountKeysRequest.KeyType.ValueType  # 1
    """User-managed keys (managed and rotated by the user)."""
    SYSTEM_MANAGED: ListServiceAccountKeysRequest.KeyType.ValueType  # 2
    """System-managed keys (managed and rotated by Google)."""

    NAME_FIELD_NUMBER: builtins.int
    KEY_TYPES_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.

    Using `-` as a wildcard for the `PROJECT_ID`, will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    @property
    def key_types(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[global___ListServiceAccountKeysRequest.KeyType.ValueType]:
        """Filters the types of keys the user wants to include in the list
        response. Duplicate key types are not allowed. If no key type
        is provided, all keys are returned.
        """

    def __init__(
        self,
        *,
        name: builtins.str = ...,
        key_types: collections.abc.Iterable[global___ListServiceAccountKeysRequest.KeyType.ValueType] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["key_types", b"key_types", "name", b"name"]) -> None: ...

global___ListServiceAccountKeysRequest = ListServiceAccountKeysRequest

@typing.final
class ListServiceAccountKeysResponse(google.protobuf.message.Message):
    """The service account keys list response."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ServiceAccountKey]:
        """The public keys for the service account."""

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[global___ServiceAccountKey] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys"]) -> None: ...

global___ListServiceAccountKeysResponse = ListServiceAccountKeysResponse

@typing.final
class GetServiceAccountKeyRequest(google.protobuf.message.Message):
    """The service account key get by id request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PUBLIC_KEY_TYPE_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account key in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}`.

    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    public_key_type: global___ServiceAccountPublicKeyType.ValueType
    """Optional. The output format of the public key. The default is `TYPE_NONE`, which
    means that the public key is not returned.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        public_key_type: global___ServiceAccountPublicKeyType.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "public_key_type", b"public_key_type"]) -> None: ...

global___GetServiceAccountKeyRequest = GetServiceAccountKeyRequest

@typing.final
class ServiceAccountKey(google.protobuf.message.Message):
    """Represents a service account key.

    A service account has two sets of key-pairs: user-managed, and
    system-managed.

    User-managed key-pairs can be created and deleted by users.  Users are
    responsible for rotating these keys periodically to ensure security of
    their service accounts.  Users retain the private key of these key-pairs,
    and Google retains ONLY the public key.

    System-managed keys are automatically rotated by Google, and are used for
    signing for a maximum of two weeks. The rotation process is probabilistic,
    and usage of the new key will gradually ramp up and down over the key's
    lifetime.

    If you cache the public key set for a service account, we recommend that you
    update the cache every 15 minutes. User-managed keys can be added and removed
    at any time, so it is important to update the cache frequently. For
    Google-managed keys, Google will publish a key at least 6 hours before it is
    first used for signing and will keep publishing it for at least 6 hours after
    it was last used for signing.

    Public keys for all service accounts are also published at the OAuth2
    Service Account API.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PRIVATE_KEY_TYPE_FIELD_NUMBER: builtins.int
    KEY_ALGORITHM_FIELD_NUMBER: builtins.int
    PRIVATE_KEY_DATA_FIELD_NUMBER: builtins.int
    PUBLIC_KEY_DATA_FIELD_NUMBER: builtins.int
    VALID_AFTER_TIME_FIELD_NUMBER: builtins.int
    VALID_BEFORE_TIME_FIELD_NUMBER: builtins.int
    KEY_ORIGIN_FIELD_NUMBER: builtins.int
    KEY_TYPE_FIELD_NUMBER: builtins.int
    DISABLED_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The resource name of the service account key in the following format
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}`.
    """
    private_key_type: global___ServiceAccountPrivateKeyType.ValueType
    """The output format for the private key.
    Only provided in `CreateServiceAccountKey` responses, not
    in `GetServiceAccountKey` or `ListServiceAccountKey` responses.

    Google never exposes system-managed private keys, and never retains
    user-managed private keys.
    """
    key_algorithm: global___ServiceAccountKeyAlgorithm.ValueType
    """Specifies the algorithm (and possibly key size) for the key."""
    private_key_data: builtins.bytes
    """The private key data. Only provided in `CreateServiceAccountKey`
    responses. Make sure to keep the private key data secure because it
    allows for the assertion of the service account identity.
    When base64 decoded, the private key data can be used to authenticate with
    Google API client libraries and with
    <a href="/sdk/gcloud/reference/auth/activate-service-account">gcloud
    auth activate-service-account</a>.
    """
    public_key_data: builtins.bytes
    """The public key data. Only provided in `GetServiceAccountKey` responses."""
    key_origin: global___ServiceAccountKeyOrigin.ValueType
    """The key origin."""
    key_type: global___ListServiceAccountKeysRequest.KeyType.ValueType
    """The key type."""
    disabled: builtins.bool
    """The key status."""
    @property
    def valid_after_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """The key can be used after this timestamp."""

    @property
    def valid_before_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """The key can be used before this timestamp.
        For system-managed key pairs, this timestamp is the end time for the
        private key signing operation. The public key could still be used
        for verification for a few hours after this time.
        """

    def __init__(
        self,
        *,
        name: builtins.str = ...,
        private_key_type: global___ServiceAccountPrivateKeyType.ValueType = ...,
        key_algorithm: global___ServiceAccountKeyAlgorithm.ValueType = ...,
        private_key_data: builtins.bytes = ...,
        public_key_data: builtins.bytes = ...,
        valid_after_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        valid_before_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        key_origin: global___ServiceAccountKeyOrigin.ValueType = ...,
        key_type: global___ListServiceAccountKeysRequest.KeyType.ValueType = ...,
        disabled: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["valid_after_time", b"valid_after_time", "valid_before_time", b"valid_before_time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["disabled", b"disabled", "key_algorithm", b"key_algorithm", "key_origin", b"key_origin", "key_type", b"key_type", "name", b"name", "private_key_data", b"private_key_data", "private_key_type", b"private_key_type", "public_key_data", b"public_key_data", "valid_after_time", b"valid_after_time", "valid_before_time", b"valid_before_time"]) -> None: ...

global___ServiceAccountKey = ServiceAccountKey

@typing.final
class CreateServiceAccountKeyRequest(google.protobuf.message.Message):
    """The service account key create request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PRIVATE_KEY_TYPE_FIELD_NUMBER: builtins.int
    KEY_ALGORITHM_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    private_key_type: global___ServiceAccountPrivateKeyType.ValueType
    """The output format of the private key. The default value is
    `TYPE_GOOGLE_CREDENTIALS_FILE`, which is the Google Credentials File
    format.
    """
    key_algorithm: global___ServiceAccountKeyAlgorithm.ValueType
    """Which type of key and algorithm to use for the key.
    The default is currently a 2K RSA key.  However this may change in the
    future.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        private_key_type: global___ServiceAccountPrivateKeyType.ValueType = ...,
        key_algorithm: global___ServiceAccountKeyAlgorithm.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["key_algorithm", b"key_algorithm", "name", b"name", "private_key_type", b"private_key_type"]) -> None: ...

global___CreateServiceAccountKeyRequest = CreateServiceAccountKeyRequest

@typing.final
class UploadServiceAccountKeyRequest(google.protobuf.message.Message):
    """The service account key upload request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PUBLIC_KEY_DATA_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    public_key_data: builtins.bytes
    """The public key to associate with the service account. Must be an RSA public
    key that is wrapped in an X.509 v3 certificate. Include the first line,
    `-----BEGIN CERTIFICATE-----`, and the last line,
    `-----END CERTIFICATE-----`.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        public_key_data: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "public_key_data", b"public_key_data"]) -> None: ...

global___UploadServiceAccountKeyRequest = UploadServiceAccountKeyRequest

@typing.final
class DeleteServiceAccountKeyRequest(google.protobuf.message.Message):
    """The service account key delete request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account key in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___DeleteServiceAccountKeyRequest = DeleteServiceAccountKeyRequest

@typing.final
class DisableServiceAccountKeyRequest(google.protobuf.message.Message):
    """The service account key disable request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account key in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}`.

    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___DisableServiceAccountKeyRequest = DisableServiceAccountKeyRequest

@typing.final
class EnableServiceAccountKeyRequest(google.protobuf.message.Message):
    """The service account key enable request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. The resource name of the service account key in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}`.

    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___EnableServiceAccountKeyRequest = EnableServiceAccountKeyRequest

@typing.final
class SignBlobRequest(google.protobuf.message.Message):
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The service account sign blob request.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    BYTES_TO_SIGN_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    bytes_to_sign: builtins.bytes
    """Required. Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The bytes to sign.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        bytes_to_sign: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["bytes_to_sign", b"bytes_to_sign", "name", b"name"]) -> None: ...

global___SignBlobRequest = SignBlobRequest

@typing.final
class SignBlobResponse(google.protobuf.message.Message):
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The service account sign blob response.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_ID_FIELD_NUMBER: builtins.int
    SIGNATURE_FIELD_NUMBER: builtins.int
    key_id: builtins.str
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The id of the key used to sign the blob.
    """
    signature: builtins.bytes
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The signed blob.
    """
    def __init__(
        self,
        *,
        key_id: builtins.str = ...,
        signature: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["key_id", b"key_id", "signature", b"signature"]) -> None: ...

global___SignBlobResponse = SignBlobResponse

@typing.final
class SignJwtRequest(google.protobuf.message.Message):
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The service account sign JWT request.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    PAYLOAD_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Required. Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The resource name of the service account in the following format:
    `projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}`.
    Using `-` as a wildcard for the `PROJECT_ID` will infer the project from
    the account. The `ACCOUNT` value can be the `email` address or the
    `unique_id` of the service account.
    """
    payload: builtins.str
    """Required. Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The JWT payload to sign. Must be a serialized JSON object that contains a
    JWT Claims Set. For example: `{"sub": "user@example.com", "iat": 313435}`

    If the JWT Claims Set contains an expiration time (`exp`) claim, it must be
    an integer timestamp that is not in the past and no more than 12 hours in
    the future.

    If the JWT Claims Set does not contain an expiration time (`exp`) claim,
    this claim is added automatically, with a timestamp that is 1 hour in the
    future.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        payload: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "payload", b"payload"]) -> None: ...

global___SignJwtRequest = SignJwtRequest

@typing.final
class SignJwtResponse(google.protobuf.message.Message):
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The service account sign JWT response.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_ID_FIELD_NUMBER: builtins.int
    SIGNED_JWT_FIELD_NUMBER: builtins.int
    key_id: builtins.str
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The id of the key used to sign the JWT.
    """
    signed_jwt: builtins.str
    """Deprecated. [Migrate to Service Account Credentials
    API](https://cloud.google.com/iam/help/credentials/migrate-api).

    The signed JWT.
    """
    def __init__(
        self,
        *,
        key_id: builtins.str = ...,
        signed_jwt: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["key_id", b"key_id", "signed_jwt", b"signed_jwt"]) -> None: ...

global___SignJwtResponse = SignJwtResponse

@typing.final
class Role(google.protobuf.message.Message):
    """A role in the Identity and Access Management API."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _RoleLaunchStage:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _RoleLaunchStageEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Role._RoleLaunchStage.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        ALPHA: Role._RoleLaunchStage.ValueType  # 0
        """The user has indicated this role is currently in an Alpha phase. If this
        launch stage is selected, the `stage` field will not be included when
        requesting the definition for a given role.
        """
        BETA: Role._RoleLaunchStage.ValueType  # 1
        """The user has indicated this role is currently in a Beta phase."""
        GA: Role._RoleLaunchStage.ValueType  # 2
        """The user has indicated this role is generally available."""
        DEPRECATED: Role._RoleLaunchStage.ValueType  # 4
        """The user has indicated this role is being deprecated."""
        DISABLED: Role._RoleLaunchStage.ValueType  # 5
        """This role is disabled and will not contribute permissions to any
        principals it is granted to in policies.
        """
        EAP: Role._RoleLaunchStage.ValueType  # 6
        """The user has indicated this role is currently in an EAP phase."""

    class RoleLaunchStage(_RoleLaunchStage, metaclass=_RoleLaunchStageEnumTypeWrapper):
        """A stage representing a role's lifecycle phase."""

    ALPHA: Role.RoleLaunchStage.ValueType  # 0
    """The user has indicated this role is currently in an Alpha phase. If this
    launch stage is selected, the `stage` field will not be included when
    requesting the definition for a given role.
    """
    BETA: Role.RoleLaunchStage.ValueType  # 1
    """The user has indicated this role is currently in a Beta phase."""
    GA: Role.RoleLaunchStage.ValueType  # 2
    """The user has indicated this role is generally available."""
    DEPRECATED: Role.RoleLaunchStage.ValueType  # 4
    """The user has indicated this role is being deprecated."""
    DISABLED: Role.RoleLaunchStage.ValueType  # 5
    """This role is disabled and will not contribute permissions to any
    principals it is granted to in policies.
    """
    EAP: Role.RoleLaunchStage.ValueType  # 6
    """The user has indicated this role is currently in an EAP phase."""

    NAME_FIELD_NUMBER: builtins.int
    TITLE_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    INCLUDED_PERMISSIONS_FIELD_NUMBER: builtins.int
    STAGE_FIELD_NUMBER: builtins.int
    ETAG_FIELD_NUMBER: builtins.int
    DELETED_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The name of the role.

    When Role is used in CreateRole, the role name must not be set.

    When Role is used in output and other input such as UpdateRole, the role
    name is the complete path, e.g., roles/logging.viewer for predefined roles
    and organizations/{ORGANIZATION_ID}/roles/logging.viewer for custom roles.
    """
    title: builtins.str
    """Optional. A human-readable title for the role.  Typically this
    is limited to 100 UTF-8 bytes.
    """
    description: builtins.str
    """Optional. A human-readable description for the role."""
    stage: global___Role.RoleLaunchStage.ValueType
    """The current launch stage of the role. If the `ALPHA` launch stage has been
    selected for a role, the `stage` field will not be included in the
    returned definition for the role.
    """
    etag: builtins.bytes
    """Used to perform a consistent read-modify-write."""
    deleted: builtins.bool
    """The current deleted state of the role. This field is read only.
    It will be ignored in calls to CreateRole and UpdateRole.
    """
    @property
    def included_permissions(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """The names of the permissions this role grants when bound in an IAM policy."""

    def __init__(
        self,
        *,
        name: builtins.str = ...,
        title: builtins.str = ...,
        description: builtins.str = ...,
        included_permissions: collections.abc.Iterable[builtins.str] | None = ...,
        stage: global___Role.RoleLaunchStage.ValueType = ...,
        etag: builtins.bytes = ...,
        deleted: builtins.bool = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["deleted", b"deleted", "description", b"description", "etag", b"etag", "included_permissions", b"included_permissions", "name", b"name", "stage", b"stage", "title", b"title"]) -> None: ...

global___Role = Role

@typing.final
class QueryGrantableRolesRequest(google.protobuf.message.Message):
    """The grantable role query request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FULL_RESOURCE_NAME_FIELD_NUMBER: builtins.int
    VIEW_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    full_resource_name: builtins.str
    """Required. The full resource name to query from the list of grantable roles.

    The name follows the Google Cloud Platform resource format.
    For example, a Cloud Platform project with id `my-project` will be named
    `//cloudresourcemanager.googleapis.com/projects/my-project`.
    """
    view: global___RoleView.ValueType
    page_size: builtins.int
    """Optional limit on the number of roles to include in the response.

    The default is 300, and the maximum is 1,000.
    """
    page_token: builtins.str
    """Optional pagination token returned in an earlier
    QueryGrantableRolesResponse.
    """
    def __init__(
        self,
        *,
        full_resource_name: builtins.str = ...,
        view: global___RoleView.ValueType = ...,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["full_resource_name", b"full_resource_name", "page_size", b"page_size", "page_token", b"page_token", "view", b"view"]) -> None: ...

global___QueryGrantableRolesRequest = QueryGrantableRolesRequest

@typing.final
class QueryGrantableRolesResponse(google.protobuf.message.Message):
    """The grantable role query response."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ROLES_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    """To retrieve the next page of results, set
    `QueryGrantableRolesRequest.page_token` to this value.
    """
    @property
    def roles(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Role]:
        """The list of matching roles."""

    def __init__(
        self,
        *,
        roles: collections.abc.Iterable[global___Role] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["next_page_token", b"next_page_token", "roles", b"roles"]) -> None: ...

global___QueryGrantableRolesResponse = QueryGrantableRolesResponse

@typing.final
class ListRolesRequest(google.protobuf.message.Message):
    """The request to get all roles defined under a resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARENT_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    VIEW_FIELD_NUMBER: builtins.int
    SHOW_DELETED_FIELD_NUMBER: builtins.int
    parent: builtins.str
    """The `parent` parameter's value depends on the target resource for the
    request, namely
    [`roles`](https://cloud.google.com/iam/reference/rest/v1/roles),
    [`projects`](https://cloud.google.com/iam/reference/rest/v1/projects.roles),
    or
    [`organizations`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles).
    Each resource type's `parent` value format is described below:

    * [`roles.list()`](https://cloud.google.com/iam/reference/rest/v1/roles/list): An empty string.
      This method doesn't require a resource; it simply returns all
      [predefined
      roles](https://cloud.google.com/iam/docs/understanding-roles#predefined_roles)
      in Cloud IAM. Example request URL: `https://iam.googleapis.com/v1/roles`

    * [`projects.roles.list()`](https://cloud.google.com/iam/reference/rest/v1/projects.roles/list):
      `projects/{PROJECT_ID}`. This method lists all project-level
      [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles).
      Example request URL:
      `https://iam.googleapis.com/v1/projects/{PROJECT_ID}/roles`

    * [`organizations.roles.list()`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles/list):
      `organizations/{ORGANIZATION_ID}`. This method lists all
      organization-level [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles).
      Example request URL:
      `https://iam.googleapis.com/v1/organizations/{ORGANIZATION_ID}/roles`

    Note: Wildcard (*) values are invalid; you must specify a complete project
    ID or organization ID.
    """
    page_size: builtins.int
    """Optional limit on the number of roles to include in the response.

    The default is 300, and the maximum is 1,000.
    """
    page_token: builtins.str
    """Optional pagination token returned in an earlier ListRolesResponse."""
    view: global___RoleView.ValueType
    """Optional view for the returned Role objects. When `FULL` is specified,
    the `includedPermissions` field is returned, which includes a list of all
    permissions in the role. The default value is `BASIC`, which does not
    return the `includedPermissions` field.
    """
    show_deleted: builtins.bool
    """Include Roles that have been deleted."""
    def __init__(
        self,
        *,
        parent: builtins.str = ...,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
        view: global___RoleView.ValueType = ...,
        show_deleted: builtins.bool = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["page_size", b"page_size", "page_token", b"page_token", "parent", b"parent", "show_deleted", b"show_deleted", "view", b"view"]) -> None: ...

global___ListRolesRequest = ListRolesRequest

@typing.final
class ListRolesResponse(google.protobuf.message.Message):
    """The response containing the roles defined under a resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ROLES_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    """To retrieve the next page of results, set
    `ListRolesRequest.page_token` to this value.
    """
    @property
    def roles(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Role]:
        """The Roles defined on this resource."""

    def __init__(
        self,
        *,
        roles: collections.abc.Iterable[global___Role] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["next_page_token", b"next_page_token", "roles", b"roles"]) -> None: ...

global___ListRolesResponse = ListRolesResponse

@typing.final
class GetRoleRequest(google.protobuf.message.Message):
    """The request to get the definition of an existing role."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The `name` parameter's value depends on the target resource for the
    request, namely
    [`roles`](https://cloud.google.com/iam/reference/rest/v1/roles),
    [`projects`](https://cloud.google.com/iam/reference/rest/v1/projects.roles),
    or
    [`organizations`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles).
    Each resource type's `name` value format is described below:

    * [`roles.get()`](https://cloud.google.com/iam/reference/rest/v1/roles/get): `roles/{ROLE_NAME}`.
      This method returns results from all
      [predefined
      roles](https://cloud.google.com/iam/docs/understanding-roles#predefined_roles)
      in Cloud IAM. Example request URL:
      `https://iam.googleapis.com/v1/roles/{ROLE_NAME}`

    * [`projects.roles.get()`](https://cloud.google.com/iam/reference/rest/v1/projects.roles/get):
      `projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`. This method returns only
      [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the project level. Example request URL:
      `https://iam.googleapis.com/v1/projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`

    * [`organizations.roles.get()`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles/get):
      `organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`. This method
      returns only [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the organization level. Example request URL:
      `https://iam.googleapis.com/v1/organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`

    Note: Wildcard (*) values are invalid; you must specify a complete project
    ID or organization ID.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

global___GetRoleRequest = GetRoleRequest

@typing.final
class CreateRoleRequest(google.protobuf.message.Message):
    """The request to create a new role."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARENT_FIELD_NUMBER: builtins.int
    ROLE_ID_FIELD_NUMBER: builtins.int
    ROLE_FIELD_NUMBER: builtins.int
    parent: builtins.str
    """The `parent` parameter's value depends on the target resource for the
    request, namely
    [`projects`](https://cloud.google.com/iam/reference/rest/v1/projects.roles)
    or
    [`organizations`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles).
    Each resource type's `parent` value format is described below:

    * [`projects.roles.create()`](https://cloud.google.com/iam/reference/rest/v1/projects.roles/create):
      `projects/{PROJECT_ID}`. This method creates project-level
      [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles).
      Example request URL:
      `https://iam.googleapis.com/v1/projects/{PROJECT_ID}/roles`

    * [`organizations.roles.create()`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles/create):
      `organizations/{ORGANIZATION_ID}`. This method creates organization-level
      [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles).
      Example request URL:
      `https://iam.googleapis.com/v1/organizations/{ORGANIZATION_ID}/roles`

    Note: Wildcard (*) values are invalid; you must specify a complete project
    ID or organization ID.
    """
    role_id: builtins.str
    """The role ID to use for this role.

    A role ID may contain alphanumeric characters, underscores (`_`), and
    periods (`.`). It must contain a minimum of 3 characters and a maximum of
    64 characters.
    """
    @property
    def role(self) -> global___Role:
        """The Role resource to create."""

    def __init__(
        self,
        *,
        parent: builtins.str = ...,
        role_id: builtins.str = ...,
        role: global___Role | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["role", b"role"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["parent", b"parent", "role", b"role", "role_id", b"role_id"]) -> None: ...

global___CreateRoleRequest = CreateRoleRequest

@typing.final
class UpdateRoleRequest(google.protobuf.message.Message):
    """The request to update a role."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    ROLE_FIELD_NUMBER: builtins.int
    UPDATE_MASK_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The `name` parameter's value depends on the target resource for the
    request, namely
    [`projects`](https://cloud.google.com/iam/reference/rest/v1/projects.roles)
    or
    [`organizations`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles).
    Each resource type's `name` value format is described below:

    * [`projects.roles.patch()`](https://cloud.google.com/iam/reference/rest/v1/projects.roles/patch):
      `projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`. This method updates only
      [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the project level. Example request URL:
      `https://iam.googleapis.com/v1/projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`

    * [`organizations.roles.patch()`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles/patch):
      `organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`. This method
      updates only [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the organization level. Example request URL:
      `https://iam.googleapis.com/v1/organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`

    Note: Wildcard (*) values are invalid; you must specify a complete project
    ID or organization ID.
    """
    @property
    def role(self) -> global___Role:
        """The updated role."""

    @property
    def update_mask(self) -> google.protobuf.field_mask_pb2.FieldMask:
        """A mask describing which fields in the Role have changed."""

    def __init__(
        self,
        *,
        name: builtins.str = ...,
        role: global___Role | None = ...,
        update_mask: google.protobuf.field_mask_pb2.FieldMask | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["role", b"role", "update_mask", b"update_mask"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["name", b"name", "role", b"role", "update_mask", b"update_mask"]) -> None: ...

global___UpdateRoleRequest = UpdateRoleRequest

@typing.final
class DeleteRoleRequest(google.protobuf.message.Message):
    """The request to delete an existing role."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    ETAG_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The `name` parameter's value depends on the target resource for the
    request, namely
    [`projects`](https://cloud.google.com/iam/reference/rest/v1/projects.roles)
    or
    [`organizations`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles).
    Each resource type's `name` value format is described below:

    * [`projects.roles.delete()`](https://cloud.google.com/iam/reference/rest/v1/projects.roles/delete):
      `projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`. This method deletes only
      [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the project level. Example request URL:
      `https://iam.googleapis.com/v1/projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`

    * [`organizations.roles.delete()`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles/delete):
      `organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`. This method
      deletes only [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the organization level. Example request URL:
      `https://iam.googleapis.com/v1/organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`

    Note: Wildcard (*) values are invalid; you must specify a complete project
    ID or organization ID.
    """
    etag: builtins.bytes
    """Used to perform a consistent read-modify-write."""
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        etag: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["etag", b"etag", "name", b"name"]) -> None: ...

global___DeleteRoleRequest = DeleteRoleRequest

@typing.final
class UndeleteRoleRequest(google.protobuf.message.Message):
    """The request to undelete an existing role."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    ETAG_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The `name` parameter's value depends on the target resource for the
    request, namely
    [`projects`](https://cloud.google.com/iam/reference/rest/v1/projects.roles)
    or
    [`organizations`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles).
    Each resource type's `name` value format is described below:

    * [`projects.roles.undelete()`](https://cloud.google.com/iam/reference/rest/v1/projects.roles/undelete):
      `projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`. This method undeletes
      only [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the project level. Example request URL:
      `https://iam.googleapis.com/v1/projects/{PROJECT_ID}/roles/{CUSTOM_ROLE_ID}`

    * [`organizations.roles.undelete()`](https://cloud.google.com/iam/reference/rest/v1/organizations.roles/undelete):
      `organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`. This method
      undeletes only [custom
      roles](https://cloud.google.com/iam/docs/understanding-custom-roles) that
      have been created at the organization level. Example request URL:
      `https://iam.googleapis.com/v1/organizations/{ORGANIZATION_ID}/roles/{CUSTOM_ROLE_ID}`

    Note: Wildcard (*) values are invalid; you must specify a complete project
    ID or organization ID.
    """
    etag: builtins.bytes
    """Used to perform a consistent read-modify-write."""
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        etag: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["etag", b"etag", "name", b"name"]) -> None: ...

global___UndeleteRoleRequest = UndeleteRoleRequest

@typing.final
class Permission(google.protobuf.message.Message):
    """A permission which can be included by a role."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _PermissionLaunchStage:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _PermissionLaunchStageEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Permission._PermissionLaunchStage.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        ALPHA: Permission._PermissionLaunchStage.ValueType  # 0
        """The permission is currently in an alpha phase."""
        BETA: Permission._PermissionLaunchStage.ValueType  # 1
        """The permission is currently in a beta phase."""
        GA: Permission._PermissionLaunchStage.ValueType  # 2
        """The permission is generally available."""
        DEPRECATED: Permission._PermissionLaunchStage.ValueType  # 3
        """The permission is being deprecated."""

    class PermissionLaunchStage(_PermissionLaunchStage, metaclass=_PermissionLaunchStageEnumTypeWrapper):
        """A stage representing a permission's lifecycle phase."""

    ALPHA: Permission.PermissionLaunchStage.ValueType  # 0
    """The permission is currently in an alpha phase."""
    BETA: Permission.PermissionLaunchStage.ValueType  # 1
    """The permission is currently in a beta phase."""
    GA: Permission.PermissionLaunchStage.ValueType  # 2
    """The permission is generally available."""
    DEPRECATED: Permission.PermissionLaunchStage.ValueType  # 3
    """The permission is being deprecated."""

    class _CustomRolesSupportLevel:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _CustomRolesSupportLevelEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Permission._CustomRolesSupportLevel.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        SUPPORTED: Permission._CustomRolesSupportLevel.ValueType  # 0
        """Default state. Permission is fully supported for custom role use."""
        TESTING: Permission._CustomRolesSupportLevel.ValueType  # 1
        """Permission is being tested to check custom role compatibility."""
        NOT_SUPPORTED: Permission._CustomRolesSupportLevel.ValueType  # 2
        """Permission is not supported for custom role use."""

    class CustomRolesSupportLevel(_CustomRolesSupportLevel, metaclass=_CustomRolesSupportLevelEnumTypeWrapper):
        """The state of the permission with regards to custom roles."""

    SUPPORTED: Permission.CustomRolesSupportLevel.ValueType  # 0
    """Default state. Permission is fully supported for custom role use."""
    TESTING: Permission.CustomRolesSupportLevel.ValueType  # 1
    """Permission is being tested to check custom role compatibility."""
    NOT_SUPPORTED: Permission.CustomRolesSupportLevel.ValueType  # 2
    """Permission is not supported for custom role use."""

    NAME_FIELD_NUMBER: builtins.int
    TITLE_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    ONLY_IN_PREDEFINED_ROLES_FIELD_NUMBER: builtins.int
    STAGE_FIELD_NUMBER: builtins.int
    CUSTOM_ROLES_SUPPORT_LEVEL_FIELD_NUMBER: builtins.int
    API_DISABLED_FIELD_NUMBER: builtins.int
    PRIMARY_PERMISSION_FIELD_NUMBER: builtins.int
    name: builtins.str
    """The name of this Permission."""
    title: builtins.str
    """The title of this Permission."""
    description: builtins.str
    """A brief description of what this Permission is used for.
    This permission can ONLY be used in predefined roles.
    """
    only_in_predefined_roles: builtins.bool
    stage: global___Permission.PermissionLaunchStage.ValueType
    """The current launch stage of the permission."""
    custom_roles_support_level: global___Permission.CustomRolesSupportLevel.ValueType
    """The current custom role support level."""
    api_disabled: builtins.bool
    """The service API associated with the permission is not enabled."""
    primary_permission: builtins.str
    """The preferred name for this permission. If present, then this permission is
    an alias of, and equivalent to, the listed primary_permission.
    """
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        title: builtins.str = ...,
        description: builtins.str = ...,
        only_in_predefined_roles: builtins.bool = ...,
        stage: global___Permission.PermissionLaunchStage.ValueType = ...,
        custom_roles_support_level: global___Permission.CustomRolesSupportLevel.ValueType = ...,
        api_disabled: builtins.bool = ...,
        primary_permission: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["api_disabled", b"api_disabled", "custom_roles_support_level", b"custom_roles_support_level", "description", b"description", "name", b"name", "only_in_predefined_roles", b"only_in_predefined_roles", "primary_permission", b"primary_permission", "stage", b"stage", "title", b"title"]) -> None: ...

global___Permission = Permission

@typing.final
class QueryTestablePermissionsRequest(google.protobuf.message.Message):
    """A request to get permissions which can be tested on a resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FULL_RESOURCE_NAME_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    full_resource_name: builtins.str
    """Required. The full resource name to query from the list of testable
    permissions.

    The name follows the Google Cloud Platform resource format.
    For example, a Cloud Platform project with id `my-project` will be named
    `//cloudresourcemanager.googleapis.com/projects/my-project`.
    """
    page_size: builtins.int
    """Optional limit on the number of permissions to include in the response.

    The default is 100, and the maximum is 1,000.
    """
    page_token: builtins.str
    """Optional pagination token returned in an earlier
    QueryTestablePermissionsRequest.
    """
    def __init__(
        self,
        *,
        full_resource_name: builtins.str = ...,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["full_resource_name", b"full_resource_name", "page_size", b"page_size", "page_token", b"page_token"]) -> None: ...

global___QueryTestablePermissionsRequest = QueryTestablePermissionsRequest

@typing.final
class QueryTestablePermissionsResponse(google.protobuf.message.Message):
    """The response containing permissions which can be tested on a resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PERMISSIONS_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    """To retrieve the next page of results, set
    `QueryTestableRolesRequest.page_token` to this value.
    """
    @property
    def permissions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Permission]:
        """The Permissions testable on the requested resource."""

    def __init__(
        self,
        *,
        permissions: collections.abc.Iterable[global___Permission] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["next_page_token", b"next_page_token", "permissions", b"permissions"]) -> None: ...

global___QueryTestablePermissionsResponse = QueryTestablePermissionsResponse

@typing.final
class QueryAuditableServicesRequest(google.protobuf.message.Message):
    """A request to get the list of auditable services for a resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FULL_RESOURCE_NAME_FIELD_NUMBER: builtins.int
    full_resource_name: builtins.str
    """Required. The full resource name to query from the list of auditable
    services.

    The name follows the Google Cloud Platform resource format.
    For example, a Cloud Platform project with id `my-project` will be named
    `//cloudresourcemanager.googleapis.com/projects/my-project`.
    """
    def __init__(
        self,
        *,
        full_resource_name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["full_resource_name", b"full_resource_name"]) -> None: ...

global___QueryAuditableServicesRequest = QueryAuditableServicesRequest

@typing.final
class QueryAuditableServicesResponse(google.protobuf.message.Message):
    """A response containing a list of auditable services for a resource."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class AuditableService(google.protobuf.message.Message):
        """Contains information about an auditable service."""

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        NAME_FIELD_NUMBER: builtins.int
        name: builtins.str
        """Public name of the service.
        For example, the service name for Cloud IAM is 'iam.googleapis.com'.
        """
        def __init__(
            self,
            *,
            name: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["name", b"name"]) -> None: ...

    SERVICES_FIELD_NUMBER: builtins.int
    @property
    def services(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___QueryAuditableServicesResponse.AuditableService]:
        """The auditable services for a resource."""

    def __init__(
        self,
        *,
        services: collections.abc.Iterable[global___QueryAuditableServicesResponse.AuditableService] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["services", b"services"]) -> None: ...

global___QueryAuditableServicesResponse = QueryAuditableServicesResponse

@typing.final
class LintPolicyRequest(google.protobuf.message.Message):
    """The request to lint a Cloud IAM policy object."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FULL_RESOURCE_NAME_FIELD_NUMBER: builtins.int
    CONDITION_FIELD_NUMBER: builtins.int
    full_resource_name: builtins.str
    """The full resource name of the policy this lint request is about.

    The name follows the Google Cloud Platform (GCP) resource format.
    For example, a GCP project with ID `my-project` will be named
    `//cloudresourcemanager.googleapis.com/projects/my-project`.

    The resource name is not used to read the policy instance from the Cloud
    IAM database. The candidate policy for lint has to be provided in the same
    request object.
    """
    @property
    def condition(self) -> google.type.expr_pb2.Expr:
        """[google.iam.v1.Binding.condition] [google.iam.v1.Binding.condition] object to be linted."""

    def __init__(
        self,
        *,
        full_resource_name: builtins.str = ...,
        condition: google.type.expr_pb2.Expr | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["condition", b"condition", "lint_object", b"lint_object"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["condition", b"condition", "full_resource_name", b"full_resource_name", "lint_object", b"lint_object"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["lint_object", b"lint_object"]) -> typing.Literal["condition"] | None: ...

global___LintPolicyRequest = LintPolicyRequest

@typing.final
class LintResult(google.protobuf.message.Message):
    """Structured response of a single validation unit."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Level:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _LevelEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[LintResult._Level.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        LEVEL_UNSPECIFIED: LintResult._Level.ValueType  # 0
        """Level is unspecified."""
        CONDITION: LintResult._Level.ValueType  # 3
        """A validation unit which operates on an individual condition within a
        binding.
        """

    class Level(_Level, metaclass=_LevelEnumTypeWrapper):
        """Possible Level values of a validation unit corresponding to its domain
        of discourse.
        """

    LEVEL_UNSPECIFIED: LintResult.Level.ValueType  # 0
    """Level is unspecified."""
    CONDITION: LintResult.Level.ValueType  # 3
    """A validation unit which operates on an individual condition within a
    binding.
    """

    class _Severity:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _SeverityEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[LintResult._Severity.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        SEVERITY_UNSPECIFIED: LintResult._Severity.ValueType  # 0
        """Severity is unspecified."""
        ERROR: LintResult._Severity.ValueType  # 1
        """A validation unit returns an error only for critical issues. If an
        attempt is made to set the problematic policy without rectifying the
        critical issue, it causes the `setPolicy` operation to fail.
        """
        WARNING: LintResult._Severity.ValueType  # 2
        """Any issue which is severe enough but does not cause an error.
        For example, suspicious constructs in the input object will not
        necessarily fail `setPolicy`, but there is a high likelihood that they
        won't behave as expected during policy evaluation in `checkPolicy`.
        This includes the following common scenarios:

        - Unsatisfiable condition: Expired timestamp in date/time condition.
        - Ineffective condition: Condition on a <principal, role> pair which is
          granted unconditionally in another binding of the same policy.
        """
        NOTICE: LintResult._Severity.ValueType  # 3
        """Reserved for the issues that are not severe as `ERROR`/`WARNING`, but
        need special handling. For instance, messages about skipped validation
        units are issued as `NOTICE`.
        """
        INFO: LintResult._Severity.ValueType  # 4
        """Any informative statement which is not severe enough to raise
        `ERROR`/`WARNING`/`NOTICE`, like auto-correction recommendations on the
        input content. Note that current version of the linter does not utilize
        `INFO`.
        """
        DEPRECATED: LintResult._Severity.ValueType  # 5
        """Deprecated severity level."""

    class Severity(_Severity, metaclass=_SeverityEnumTypeWrapper):
        """Possible Severity values of an issued result."""

    SEVERITY_UNSPECIFIED: LintResult.Severity.ValueType  # 0
    """Severity is unspecified."""
    ERROR: LintResult.Severity.ValueType  # 1
    """A validation unit returns an error only for critical issues. If an
    attempt is made to set the problematic policy without rectifying the
    critical issue, it causes the `setPolicy` operation to fail.
    """
    WARNING: LintResult.Severity.ValueType  # 2
    """Any issue which is severe enough but does not cause an error.
    For example, suspicious constructs in the input object will not
    necessarily fail `setPolicy`, but there is a high likelihood that they
    won't behave as expected during policy evaluation in `checkPolicy`.
    This includes the following common scenarios:

    - Unsatisfiable condition: Expired timestamp in date/time condition.
    - Ineffective condition: Condition on a <principal, role> pair which is
      granted unconditionally in another binding of the same policy.
    """
    NOTICE: LintResult.Severity.ValueType  # 3
    """Reserved for the issues that are not severe as `ERROR`/`WARNING`, but
    need special handling. For instance, messages about skipped validation
    units are issued as `NOTICE`.
    """
    INFO: LintResult.Severity.ValueType  # 4
    """Any informative statement which is not severe enough to raise
    `ERROR`/`WARNING`/`NOTICE`, like auto-correction recommendations on the
    input content. Note that current version of the linter does not utilize
    `INFO`.
    """
    DEPRECATED: LintResult.Severity.ValueType  # 5
    """Deprecated severity level."""

    LEVEL_FIELD_NUMBER: builtins.int
    VALIDATION_UNIT_NAME_FIELD_NUMBER: builtins.int
    SEVERITY_FIELD_NUMBER: builtins.int
    FIELD_NAME_FIELD_NUMBER: builtins.int
    LOCATION_OFFSET_FIELD_NUMBER: builtins.int
    DEBUG_MESSAGE_FIELD_NUMBER: builtins.int
    level: global___LintResult.Level.ValueType
    """The validation unit level."""
    validation_unit_name: builtins.str
    """The validation unit name, for instance
    "lintValidationUnits/ConditionComplexityCheck".
    """
    severity: global___LintResult.Severity.ValueType
    """The validation unit severity."""
    field_name: builtins.str
    """The name of the field for which this lint result is about.

    For nested messages `field_name` consists of names of the embedded fields
    separated by period character. The top-level qualifier is the input object
    to lint in the request. For example, the `field_name` value
    `condition.expression` identifies a lint result for the `expression` field
    of the provided condition.
    """
    location_offset: builtins.int
    """0-based character position of problematic construct within the object
    identified by `field_name`. Currently, this is populated only for condition
    expression.
    """
    debug_message: builtins.str
    """Human readable debug message associated with the issue."""
    def __init__(
        self,
        *,
        level: global___LintResult.Level.ValueType = ...,
        validation_unit_name: builtins.str = ...,
        severity: global___LintResult.Severity.ValueType = ...,
        field_name: builtins.str = ...,
        location_offset: builtins.int = ...,
        debug_message: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["debug_message", b"debug_message", "field_name", b"field_name", "level", b"level", "location_offset", b"location_offset", "severity", b"severity", "validation_unit_name", b"validation_unit_name"]) -> None: ...

global___LintResult = LintResult

@typing.final
class LintPolicyResponse(google.protobuf.message.Message):
    """The response of a lint operation. An empty response indicates
    the operation was able to fully execute and no lint issue was found.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LINT_RESULTS_FIELD_NUMBER: builtins.int
    @property
    def lint_results(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___LintResult]:
        """List of lint results sorted by `severity` in descending order."""

    def __init__(
        self,
        *,
        lint_results: collections.abc.Iterable[global___LintResult] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["lint_results", b"lint_results"]) -> None: ...

global___LintPolicyResponse = LintPolicyResponse
